lexer grammar AssemblerLexer;

WS		:	(' '|'\t')+ -> skip;
NL		:	'\r'? '\n' -> skip;
LINE_COMMENT	:	';' ~[\r\n]*;


ADD_		:	'+';
MIN_		:	'-';
MUL_		:	'*';
DIV_		:	'/';
MOD_		:	'%';
SQU_		:	'^';

MATH_EXPRESSION	:	('0x' [0-9a-zA-Z]+ | [0-9]+) (
						'0x' [0-9a-zA-Z]+
						|	[0-9]+
						|	ADD_
						|	MIN_
						|	MUL_
						|	DIV_
						|	WS
						|	OPEN_SMALL_BRACKET MATH_EXPRESSION CLOSE_SMALL_BRACKET
					)*
				;

/*
MATH_SYMBOL     :       '+'
                |       '-'
                |       '*'
                |       '\\'
                ;*/
COMMA		:	',';
COLON		:	':';
DB_SYMBOL	:	'db';

OPEN_BIG_BRACKET	:	'{';
CLOSE_BIG_BRACKET	:	'}';

OPEN_SMALL_BRACKET	:	'(';
CLOSE_SMALL_BRACKET	:	')';

OPEN_MID_BRACKET		:	'[';
CLOSE_MID_BRACKET		:	']';


BYTE_START	:	'byte';
WORD_START	:	'word';
DWORD_START	:	'dword';
QWORD_START	:	'qword';



BIT16	:	'(bits 16)';
BIT32	:	'(bits 32)';
BIT64	:	'(bits 64)';

AAA		:	'aaa';
AAD		:	'aad';
AAM		:	'aam';
AAS		:	'aas';
ADC		:	'adc';
ADCX		:	'adcx';
ADD		:	'add';
ADDPD		:	'addpd';
VADDPD		:	'vaddpd';
ADDPS		:	'addps';
VADDPS		:	'vaddps';
ADDSD		:	'addsd';
VADDSD		:	'vaddsd';
ADDSS		:	'addss';
VADDSS		:	'vaddss';
ADDSUBPD	:	'addsubpd';
VADDSUBPD	:	'vaddsubpd';
ADDSUBPS	:	'addsubps';
VADDSUBPS	:	'vaddsubps';
ADOX		:	'adox';
AESDEC		:	'aesdec';
VAESDEC		:	'vaesdec';
AESDECLAST	:	'aesdeclast';
VAESDECLAST	:	'vaesdeclast';
AESENC		:	'aesenc';
VAESENC		:	'vaesenc';
AESENCLAST	:	'aesenclast';
VAESENCLAST	:	'vaesenclast';
AESIMC		:	'aesimc';
VAESIMC		:	'vaesimc';
AESKEYGENASSIST	:	'aeskeygenassist';
VAESKEYGENASSIST:	'vaeskeygenassist';
AND		:	'and';
ANDN		:	'andn';
ANDPD		:	'andpd';
VANDPD		:	'vandpd';
ANDPS		:	'andps';
VANDPS		:	'vandps';
ANDNPD		:	'andnpd';
VANDNPD		:	'vandnpd';
ANDNPS		:	'andnps';
VANDNPS		:	'vandnps';
ARPL            :       'arpl';
BEXTR		:	'bextr';
BLENDPD		:	'blendpd';
VBLENDPD	:	'vblendpd';
BLENDPS		:	'blendps';
VBLENDPS	:	'vblendps';
BLENDVPD	:	'blendvpd';
VBLENDVPD	:	'vblendvpd';
BLENDVPS	:	'blendvps';
VBLENDVPS	:	'vblendvps';
BLSI            :	'blsi';
BLSMSK          :	'blsmsk';
BLSR            :	'blsr';
BNDCL           :	'bndcl';
BNDCU           :	'bndcu';
BNDCN           :	'bndcn';
BNDLDX          :	'bndldx';
BNDMK           :	'bndmk';
BNDMOV          :	'bndmov';
BNDSTX          :	'bndstx';
BOUND           :	'bound';
BSF             :       'bsf';
BSR             :       'bsr';
BSWAP           :       'bswap';
BT              :	'bt';
BTC             :	'btc';
BTR             :	'btr';
BTS             :	'bts';
BZHI            :	'bzhi';
CALL            :	'call';
CBW		:	'cbw';
CWDE		:	'cwde';
CDQE		:	'cdqe';
CLAC            :	'clac';
CLC		:	'clc';
CLD             :       'cld';
CLDEMOTE        :	'cldemote';
CLFLUSH         :	'clflush';
CLFLUSHOPT      :	'clflushopt';
CLI		:	'cli';
CLTS		:	'clts';
CLRSSBSY        :       'clrssbsy';
CLWB            :	'clwb';
CMC		:	'cmc';
/*CMOVA           :	'cmova';
CMOVAE          :	'cmovae';
CMOVB           :	'cmovb';
CMOVBE          :	'cmovbe';
CMOVC           :	'cmovc';
CMOVE           :	'cmove';
CMOVG           :	'cmovg';
CMOVGE          :	'cmovge';
CMOVL		:	'cmovl';
CMOVLE		:	'cmovle';
CMOVNA		:	'cmovna';
CMOVNAE		:	'cmovnae';
CMOVNB		:	'cmovnb';
CMOVNBE		:	'cmovnbe';
CMOVNC		:	'cmovnc';
CMOVNE		:	'cmovne';
CMOVNG		:	'cmovng';
CMOVNGE		:	'cmovnge';
CMOVNL		:	'cmovnl';
CMOVNLE		:	'cmovnle';
CMOVNO		:	'cmovno';
CMOVNP		:	'cmovnp';
CMOVNS		:	'cmovns';
CMOVNZ		:	'cmovnz';
CMOVO		:	'cmovo';
CMOVP		:	'cmovp';
CMOVPE		:	'cmovpe';
CMOVPO		:	'cmovpo';
CMOVS		:	'cmovs';
CMOVZ		:	'cmovz';*/
CMOVCC		:'cmova'|'cmovae'|'cmovb'|'cmovbe'|'cmovc'|'cmove'|'cmovg'|'cmovge'|'cmovl'|'cmovle'|'cmovna'|'cmovnae'|'cmovnb'|'cmovnbe'|'cmovnc'|'cmovne'|'cmovng'|'cmovnge'|'cmovnl'|'cmovnle'|'cmovno'|'cmovnp'|'cmovns'|'cmovnz'|'cmovo'|'cmovp'|'cmovpe'|'cmovpo'|'cmovs'|'cmovz';
CMP		:	'cmp';
CMPPD		:	'cmppd';
VCMPPD		:	'vcmppd';
CMPPS		:	'cmpps';
VCMPPS		:	'vcmpps';
CMPS		:	'cmps';
CMPSB		:	'cmpsb';
CMPSW		:	'cmpsw';
CMPSD		:	'cmpsd';
CMPSQ		:	'cmpsq';
VCMPSD		:	'vcmpsd';
CMPSS		:	'cmpss';
VCMPSS		:	'vcmppss';
CMPXCHG		:	'cmpxchg';
CMPXCHG8B	:	'cmpxchg8b';
CMPXCHG16B	:	'cmpxchg16b';
COMISD		:	'comisd';
VCOMISD		:	'vcomisd';
COMISS          :       'comiss';
VCOMISS		:	'vcomiss';
CPUID           :       'cpuid';
CRC32		:	'crc32';
CVTDQ2PD	:	'cvtdq2pd';
VCVTDQ2PD	:	'vcvtdq2pd';
CVTDQ2PS	:	'cvtdq2ps';
VCVTDQ2PS	:	'vcvtdq2ps';
CVTPD2DQ	:	'cvtpd2dq';
VCVTPD2DQ	:	'vcvtpd2dq';
CVTPD2PI	:	'cvtpd2pi';
CVTPD2PS	:	'cvtpd2ps';
VCVTPD2PS	:	'vcvtpd2ps';
CVTPI2PD	:	'cvtpi2pd';
CVTPI2PS	:	'cvtpi2ps';
CVTPS2DQ	:	'cvtps2dq';
VCVTPS2DQ	:	'vcvtps2dq';
CVTPS2PD	:	'cvtps2pd';
VCVTPS2PD	:	'vcvtps2pd';
CVTPS2PI	:	'cvtps2pi';
CVTSD2SI	:	'cvtsd2si';
VCVTSD2SI	:	'vcvtsd2si';
CVTSD2SS	:	'cvtsd2ss';
VCVTSD2SS	:	'vcvtsd2ss';
CVTSI2SD	:	'cvtsi2sd';
VCVTSI2SD	:	'vcvtsi2sd';
CVTSI2SS	:	'cvtsi2ss';
VCVTSI2SS	:	'vcvtsi2ss';
CVTSS2SD	:	'cvtss2sd';
VCVTSS2SD	:	'vcvtss2sd';
CVTSS2SI	:	'cvtss2si';
VCVTSS2SI	:	'vcvtss2si';
CVTTPD2DQ	:	'cvttpd2dq';
VCVTTPD2DQ	:	'vcvttpd2dq';
CVTTPD2PI	:	'cvttpd2pi';
CVTTPS2DQ	:	'cvttps2dq';
VCVTTPS2DQ	:	'vcvttps2dq';
CVTTPS2PI	:	'cvttps2pi';
CVTTSD2SI	:	'cvttsd2si';
VCVTTSD2SI	:	'vcvttsd2si';
CVTTSS2SI	:	'cvttss2si';
VCVTTSS2SI	:	'vcvttss2si';
CWD     	:	'cwd';
CDQ     	:	'cdq';
CQO     	:	'cqo';
DAA		:	'daa';
DAS		:	'das';
DEC		:	'dec';
DIV		:	'div';
DIVPD		:	'divpd';
VDIVPD		:	'vdivpd';
DIVPS		:	'divps';
VDIVPS		:	'vdivps';
DIVSD		:	'divsd';
VDIVSD		:	'vdivsd';
DIVSS		:	'divss';
VDIVSS		:	'vdivss';
DPPD		:	'dppd';
VDPPD		:	'vdppd';
DPPS		:	'dpps';
VDPPS		:	'vdpps';
EMMS		:	'emms';
ENTER		:	'enter';
EXTRACTPS	:	'extractps';
VEXTRACTPS	:	'vextractps';
F2XM1   	:	'f2xm1';
FABS    	:	'fabs';
FADD    	:	'fadd';
FADDP   	:	'faddp';
FIADD   	:	'fiadd';
FBLD           	:	'fbld';
FBSTP   	:	'fbstp';
FCHS		:	'fchs';
FCLEX		:	'fclex';
FNCLEX		:	'fnclex';
FCMOVB		:	'fcmovb';
FCMOVE		:	'fcmove';
FCMOVBE		:	'fcmovbe';
FCMOVU		:	'fcmovu';
FCMOVNB		:	'fcmovnb';
FCMOVNE		:	'fcmovne';
FCMOVNBE	:	'fcmovnbe';
FCMOVNU		:	'fcmovnu';
FCOM		:	'fcom';
FCOMP		:	'fcomp';
FCOMPP		:	'fcompp';
FCOMI		:	'fcomi';
FCOMIP		:	'fcomip';
FUCOMI		:	'fucomi';
FUCOMIP		:	'fucomip';
FCOS		:	'fcos';
FDECSTP		:	'fdecstp';
FDIV		:	'fdiv';
FDIVP		:	'fdivp';
FIDIV		:	'fidiv';
FDIVR		:	'fdivr';
FDIVRP		:	'fdivrp';
FIDIVR		:	'fidivr';
FFREE		:	'ffree';
FICOM		:	'ficom';
FICOMP		:	'ficomp';
FILD		:	'fild';
FINCSTP		:	'fincstp';
FINIT		:	'finit';
FNINIT		:	'fninit';
FIST		:	'fist';
FISTP		:	'fistp';
FISTTP		:	'fisttp';
FLD		:	'fld';
FLD1		:	'fld1';
FLDL2T		:	'fldl2t';
FLDL2E		:	'fldl2e';
FLDPI		:	'fldpi';
FLDLG2		:	'fldlg2';
FLDLN2		:	'fldln2';
FLDZ		:	'fldz';
FLDCW		:	'fldcw';
FLDENV		:	'fldenv';
FMUL		:	'fmul';
FMULP		:	'fmulp';
FIMUL		:	'fimul';
FNOP		:	'fnop';
FPATAN		:	'fpatan';
FPREM		:	'fprem';
FPREM1		:	'fprem1';
FPTAN		:	'fptan';
FRNDINT		:	'frndint';
FRSTOR		:	'frstor';
FSAVE		:	'fsave';
FNSAVE		:	'fnsave';
FSCALE		:	'fscale';
FSIN		:	'fsin';
FSINCOS		:	'fsincos';
FSQRT		:	'fsqrt';
FST		:	'fst';
FSTP		:	'fstp';
FSTCW		:	'fstcw';
FNSTCW		:	'fnstcw';
FSTENV		:	'fstenv';
FNSTENV		:	'fnstenv';
FSTSW		:	'fstsw';
FNSTSW		:	'fnstsw';
FSUB		:	'fsub';
FSUBP		:	'fsubp';
FISUB		:	'fisub';
FSUBR		:	'fsubr';
FSUBRP		:	'fsubrp';
FISUBR		:	'fisubr';
FTST		:	'ftst';
FUCOM		:	'fucom';
FTCOMP		:	'ftcomp';
FUCOMPP		:	'fucompp';
FXAM		:	'fxam';
FXCH		:	'fxch';
FXRSTOR		:	'fxrstor';
FXRSTOR64	:	'fxrstor64';
FXSAVE		:	'fxsave';
FXSAVE64	:	'fxsave64';
FXTRACT		:	'fxtract';
FYL2X		:	'fyl2x';
FYL2XP1		:	'fyl2xp1';
GF2P8AFFINEINVQB:	'gf2p8affineinvqb';
GF2P8AFFINEQB	:	'gf2p8affineqb';
GF2P8MULB	:	'gf2p8mulb';
HADDPD		:	'haddpd';
VHADDPD		:	'vhaddpd';
HADDPS		:	'haddps';
VHADDPS		:	'vhaddps';
HLT		:	'hlt';
HSUBPD		:	'hsubpd';
VHSUBPD		:	'vhsubpd';
HSUBPS		:	'hsubps';
VHSUBPS		:	'vhsubps';
IDIV		:	'idiv';
IMUL		:	'imul';
IN		:	'in';
INC		:	'inc';
INS		:	'ins';
INSB		:	'insb';
INSW		:	'insw';
INSD		:	'insd';
INSERTPS	:	'insertps';
VINSERTPS	:	'vinsertps';
INT3		:	'int3';
INT		:	'int';
INT0		:	'into';
INT1		:	'int1';
INVD		:	'invd';
INVLPG		:	'invlpg';
INVPCID		:	'invpcid';
IRET		:	'iret';
IRETD		:	'iretd';
IRETQ		:	'iretq';
JA		:	'ja';
JAE		:	'jae';
JB		:	'jb';
JBE		:	'jbe';
JC		:	'jc';
JCXZ		:	'jcxz';
JECXZ		:	'jecxz';
JRCXZ		:	'jrcxz';
JE		:	'je';
JG		:	'jg';
JGE		:	'jge';
JL		:	'jl';
JLE		:	'jle';
JNA		:	'jna';
JNAE		:	'jnae';
JNB		:	'jnb';
JNBE		:	'jnbe';
JNC		:	'jnc';
JNE		:	'jne';
JNG		:	'jng';
JNGE		:	'jnge';
JNL		:	'jnl';
JNLE		:	'jnle';
JNO		:	'jno';
JNP		:	'jnp';
JNS		:	'jns';
JNZ		:	'jnz';
JO		:	'jo';
JP		:	'jp';
JPE		:	'jpe';
JPO		:	'jpo';
JS		:	'js';
JZ		:	'jz';
JMP		:	'jmp';
KADDW		:	'kaddw';
KADDB		:	'kaddb';
KADDQ		:	'kaddq';
KADDD		:	'kaddd';
KANDW		:	'kandw';
KANDB		:	'kandb';
KANDQ		:	'kandq';
KANDD		:	'kandd';
KANDNW		:	'kandnw';
KANDNB		:	'kandnb';
KANDNQ		:	'kandnq';
KANDND		:	'kandnd';
KMOVW		:	'kmovw';
KMOVB		:	'kmovb';
KMOVQ		:	'kmovq';
KMOVD		:	'kmovd';
KNOTW		:	'knotw';
KNOTB		:	'knotb';
KNOTQ		:	'knotq';
KNOTD		:	'knotd';
KORW		:	'korw';
KORB		:	'korb';
KORQ		:	'korq';
KORD		:	'kord';
KORTESTW	:	'kortestw';
KORTESTB	:	'kortestb';
KORTESTQ	:	'kortestq';
KORTESTD	:	'kortestd';
KSHIFTLW	:	'kshiftlw';
KSHIFTLB	:	'kshiftlb';
KSHIFTLQ	:	'kshiftlq';
KSHIFTLD	:	'kshiftld';
KSHIFTRW	:	'kshiftrw';
KSHIFTRB	:	'kshiftrb';
KSHIFTRQ	:	'kshiftrq';
KSHIFTRD	:	'kshiftrd';
KTESTW  	:	'ktestw';
KTESTB  	:	'ktestb';
KTESTQ  	:	'ktestq';
KTESTD  	:	'ktestd';
KUNPCKBW  	:	'kunpckbw';
KUNPCKWD  	:	'kunpckwd';
KUNPCKDQ  	:	'kunpckdq';
KXNORW  	:	'kxnorw';
KXNORB  	:	'kxnorb';
KXNORQ  	:	'kxnorq';
KXNORD  	:	'kxnord';
KXORW     	:	'kxorw';
KXORB     	:	'kxorb';
KXORQ     	:	'kxorq';
KXORD     	:	'kxord';
LAHF		:	'lahf';
LAR     	:	'lar';
LDDQU     	:	'lddqu';
VLDDQU     	:	'vlddqu';
LDMXCSR     	:	'ldmxcsr';
VLDMXCSR     	:	'vldmxcsr';
LDS     	:	'lds';
LSS     	:	'lss';
LES     	:	'les';
LFS     	:	'lfs';
LGS     	:	'lgs';
LEA     	:	'lea';
LEAVE		:	'leave';
LFENCE     	:	'lfence';
LGDT     	:	'lgdt';
LIDT     	:	'lidt';
LLDT     	:	'lldt';
LMSW     	:	'lmsw';
LOCK		:	'lock';
LODS     	:	'lods';
LODSB     	:	'lodsb';
LODSW     	:	'lodsw';
LODSD     	:	'lodsd';
LODSQ     	:	'lodsq';
LOOP     	:	'loop';
LOOPE     	:	'loope';
LOOPNE     	:	'loopne';
LSL     	:	'lsl';
LTR     	:	'ltr';
LZCNT     	:	'lzcnt';
MASKMOVDQU     	:	'maskmovdqu';
VMASKMOVDQU     	:	'vmaskmovdqu';
MASKMOVQ     	:	'maskmovq';
MAXPD     	:	'maxpd';
VMAXPD     	:	'vmaxpd';
MAXPS     	:	'maxps';
VMAXPS     	:	'vmaxps';
MAXSD     	:	'maxsd';
VMAXSD     	:	'vmaxsd';
MAXSS     	:	'maxss';
VMAXSS     	:	'vmaxss';
MFENCE     	:	'mfence';
MINPD     	:	'minpd';
VMINPD     	:	'vminpd';
MINPS     	:	'minps';
VMINPS     	:	'vminps';
MINSD     	:	'minsd';
VMINSD     	:	'vminsd';
MINSS     	:	'minss';
VMINSS     	:	'vminss';
MONITOR		:	'monitor';
MOV     	:	'mov';
MOVAPD     	:	'movapd';
VMOVAPD     	:	'vmovapd';
MOVAPS     	:	'movaps';
VMOVAPS     	:	'vmovaps';
MOVBE		:	'movbe';
MOVD     	:	'movd';
MOVQ     	:	'movq';
VMOVD     	:	'vmovd';
VMOVQ		:	'vmovq';
MOVDDUP     	:	'movddup';
VMOVDDUP     	:	'vmovddup';
MOVDIRI     	:	'movdiri';
MOVDIR64B     	:	'movdir64b';
MOVDQA     	:	'movdqa';
VMOVDQA     	:	'vmovdqa';
VMOVDQA32     	:	'vmovdqa32';
VMOVDQA64     	:	'vmovdqa64';
MOVDQU     	:	'movdqu';
VMOVDQU     	:	'vmovdqu';
VMOVDQU8     	:	'vmovdqu8';
VMOVDQU16     	:	'vmovdqu16';
VMOVDQU32     	:	'vmovdqu32';
VMOVDQU64     	:	'vmovdqu64';
MOVDQ2Q    	:	'movdq2q';
MOVHLPS    	:	'movhlps';
VMOVHLPS    	:	'vmovhlps';
MOVHPD    	:	'movhpd';
VMOVHPD    	:	'vmovhpd';
MOVHPS    	:	'movhps';
VMOVHPS    	:	'vmovhps';
MOVLHPS    	:	'movlhps';
VMOVLHPS    	:	'vmovlhps';
MOVLPD    	:	'movlpd';
VMOVLPD    	:	'vmovlpd';
MOVLPS    	:	'movlps';
VMOVLPS    	:	'vmovlps';
MOVMSKPD    	:	'movmskpd';
VMOVMSKPD    	:	'vmovmskpd';
MOVMSKPS    	:	'movmskps';
VMOVMSKPS    	:	'vmovmskps';
MOVNTDQA    	:	'movntdqa';
VMOVNTDQA    	:	'vmovntdqa';
MOVNTDQ    	:	'movntdq';
VMOVNTDQ    	:	'vmovntdq';
MOVNTI    	:	'movnti';
MOVNTPD    	:	'movntpd';
VMOVNTPD    	:	'vmovntpd';
MOVNTPS    	:	'movntps';
VMOVNTPS    	:	'vmovntps';
MOVNTQ    	:	'movntq';
//MOVQ    	:	'movq';
//VMOVQ    	:	'vmovq';
MOVQ2DQ         :       'movq2dq';
MOVS            :       'movs';
MOVSB           :       'movsb';
MOVSW           :       'movsw';
MOVSD           :       'movsd';
MOVSQ           :       'movsq';
VMOVSD          :       'vmovsd';
MOVSHDUP        :       'movshdup';
VMOVSHDUP       :       'vmovshdup';
MOVSLDUP        :       'movsldup';
VMOVSLDUP       :       'vmovsldup';
MOVSS           :       'movss';
VMOVSS          :       'vmovss';
MOVSX           :       'movsx';
MOVSXD          :       'movsxd';
MOVUPD          :       'movupd';
VMOVUPD         :       'vmovupd';
MOVUPS          :       'movups';
VMOVUPS         :       'vmovups';
MOVZX           :       'movzx';
MPSADBW         :       'mpsadbw';
VMPSADBW        :       'vmpsadbw';
MUL             :       'mul';
MULPD           :       'mulpd';
VMULPD          :       'vmulpd';
MULPS           :       'mulps';
VMULPS          :       'vmulps';
MULSD           :       'mulsd';
VMULSD          :       'vmulsd';
MULSS           :       'mulss';
VMULSS          :       'vmulss';
MULX            :       'mulx';
MWAIT           :       'mwait';
NEG             :       'neg';
NOP             :       'nop';
NOT             :       'not';
OR              :       'or';
ORPD            :       'orpd';
VORPD           :       'vorpd';
ORPS            :       'orps';
VORPS           :       'vorps';
OUT             :       'out';
OUTS		:	'outs';
OUTSB		:	'outsb';
OUTSW		:	'outsw';
OUTSD		:	'outsd';
PABSB           :       'pabsb';
PABSW           :       'pabsw';
PABSD           :       'pabsd';
VPABSB          :       'vpabsb';
VPABSW          :       'vpabsw';
VPABSD          :       'vpabsd';
VPABSQ          :       'vpabsq ';
PACKSSWB        :       'packsswb';
PACKSSDW        :       'packssdw';
VPACKSSWB       :       'vpacksswb';
VPACKSSDW       :       'vpackssdw';
PACKUSDW        :       'packusdw';
VPACKUSDW       :       'vpackusdw';
PACKUSWB        :       'packuswb';
VPACKUSWB       :       'vpackuswb';
PADDB           :       'paddb';
PADDW           :       'paddw';
PADDD           :       'paddd';
PADDQ           :       'paddq';
VPADDB          :       'vpaddb';
VPADDW          :       'vpaddw';
VPADDD          :       'vpaddd';
VPADDQ          :       'vpaddq';
PADDSB          :       'paddsb';
PADDSW          :       'paddsw';
VPADDSB         :       'vpaddsb';
VPADDSW         :       'vpaddsw';
PADDUSB         :       'paddusb';
PADDUSW         :       'paddusw';
VPADDUSB        :       'vpaddusb';
VPADDUSW        :       'vpaddusw';
PALIGNR         :       'palignr';
VPALIGNR        :       'vpalignr';
PAND            :       'pand';
VPAND           :       'vpand';
VPANDD          :       'vpandd';
VPANDQ          :       'vpandq';
PANDN           :       'pandn';
VPANDN          :       'vpandn';
VPANDND         :       'vpandnd';
VPANDNQ         :       'vpandnq';
PAUSE		:	'pause';
PAVGB           :       'pavgb';
PAVGW           :       'pavgw';
VPAVGB          :       'vpavgb';
VPAVGW          :       'vpavgw';
PBLENDVB        :       'pblendvb';
VPBLENDVB       :       'vpblendvb';
PBLENDW         :       'pblendw';
VPBLENDW        :       'vpblendw';
PCLMULQDQ       :       'pclmulqdq';
VPCLMULQDQ      :       'vpclmulqdq';
PCMPEQB         :       'pcmpeqb';
PCMPEQW         :       'pcmpeqw';
PCMPEQD         :       'pcmpeqd';
VPCMPEQB        :       'vpcmpeqb';
VPCMPEQW        :       'vpcmpeqw';
VPCMPEQD        :       'vpcmpeqd';
PCMPEQQ         :       'pcmpeqq';
VPCMPEQQ        :       'vpcmpeqq';
PCMPESTRI       :       'pcmpestri';
VPCMPESTRI      :       'vpcmpestri';
PCMPESTRM       :       'pcmpestrm';
VPCMPESTRM      :       'vpcmpestrm';
PCMPGTB         :       'pcmpgtb';
PCMPGTW         :       'pcmpgtw';
PCMPGTD         :       'pcmpgtd';
VPCMPGTB        :       'vpcmpgtb';
VPCMPGTW        :       'vpcmpgtw';
VPCMPGTD        :       'vpcmpgtd';
PCMPGTQ         :       'pcmpgtq';
VPCMPGTQ        :       'vpcmpgtq';
PCMPISTRI       :       'pcmpistri';
VPCMPISTRI      :       'vpcmpistri';
PCMPISTRM       :       'pcmpistrm';
VPCMPISTRM      :       'vpcmpistrm';
PDEP            :       'pdep';
PEXT            :       'pext';
PEXTRB          :       'pextrb';
PEXTRD          :       'pextrd';
PEXTRQ          :       'pextrq';
VPEXTRB         :       'vpextrb';
VPEXTRD         :       'vpextrd';
VPEXTRQ         :       'vpextrq';
PEXTRW          :       'pextrw';
VPEXTRW         :       'vpextrw';
PHADDW          :       'phaddw';
PHADDD          :       'phaddd';
VPHADDW         :       'vphaddw';
VPHADDD         :       'vphaddd';
PHADDSW         :       'phaddsw';
VPHADDSW        :       'vphaddsw';
PHMINPOSUW      :       'phminposuw';
VPHMINPOSUW     :       'vphminposuw';
PHSUBW          :       'phsubw';
PHSUBD          :       'phsubd';
VPHSUBW         :       'vphsubw';
VPHSUBD         :       'vphsubd';
PHSUBSW         :       'phsubsw';
VPHSUBSW        :       'vphsubsw';
PINSRB          :       'pinsrb';
PINSRD          :       'pinsrd';
PINSRQ          :       'pinsrq';
VPINSRB         :       'vpinsrb';
VPINSRD         :       'vpinsrd';
VPINSRQ         :       'vpinsrq';
PINSRW          :       'pinsrw';
VPINSRW         :       'vpinsrw';
PMADDUBSW       :       'pmaddubsw';
VPMADDUBSW      :       'vpmaddubsw';
PMADDWD         :       'pmaddwd';
VPMADDWD        :       'vpmaddwd';
PMAXSW          :       'pmaxsw';
PMAXSB          :       'pmaxsb';
PMAXSD          :       'pmaxsd';
VPMAXSB         :       'vpmaxsb';
VPMAXSW         :       'vpmaxsw';
VPMAXSD         :       'vpmaxsd';
PMAXUB          :       'pmaxub';
PMAXUW          :       'pmaxuw';
VPMAXUB         :       'vpmaxub';
VPMAXUW         :       'vpmaxuw';
PMAXUD          :       'pmaxud';
VPMAXUD         :       'vpmaxud';
VPMAXUQ         :       'vpmaxuq';
PMINSW          :       'pminsw';
PMINSB          :       'pminsb';
VPMINSB         :       'vpminsb';
VPMINSW         :       'vpminsw';
PMINSD          :       'pminsd';
VPMINSD         :       'vpminsd';
VPMINSQ         :       'vpminsq';
PMINUB          :       'pminub';
PMINUW          :       'pminuw';
VPMINUB         :       'vpminub';
VPMINUW         :       'vpminuw';
PMINUD          :       'pminud';
VPMINUD         :       'vpminud';
VPMINUQ         :       'vpminuq';
PMOVMSKB        :       'pmovmskb';
VPMOVMSKB       :       'vpmovmskb';
PMOVSXBW        :       'pmovsxbw';
PMOVSXBD        :       'pmovsxbd';
PMOVSXBQ        :       'pmovsxbq';
PMOVSXWD        :       'pmovsxwd';
PMOVSXWQ        :       'pmovsxwq';
PMOVSXDQ        :       'pmovsxdq';
VPMOVSXBW       :       'vpmovsxbw';
VPMOVSXBD       :       'vpmovsxbd';
VPMOVSXBQ       :       'vpmovsxbq';
VPMOVSXWD       :       'vpmovsxwd';
VPMOVSXWQ       :       'vpmovsxwq';
VPMOVSXDQ       :       'vpmovsxdq';
PMOVZXBW        :       'pmovzxbw';
PMOVZXBD        :       'pmovzxbd';
PMOVZXBQ        :       'pmovzxbq';
PMOVZXWD        :       'pmovzxwd';
PMOVZXWQ        :       'pmovzxwq';
PMOVZXDQ        :       'pmovzxdq';
VPMOVZXBW       :       'vpmovzxbw';
VPMOVZXBD       :       'vpmovzxbd';
VPMOVZXBQ       :       'vpmovzxbq';
VPMOVZXWD       :       'vpmovzxwd';
VPMOVZXWQ       :       'vpmovzxwq';
VPMOVZXDQ       :       'vpmovzxdq';
PMULDQ          :       'pmuldq';
VPMULDQ         :       'vpmuldq';
PMULHRSW        :       'pmulhrsw';
VPMULHRSW       :       'vpmulhrsw';
PMULHUW         :       'pmulhuw';
VPMULHUW        :       'vpmulhuw';
PMULHW          :       'pmulhw';
VPMULHW         :       'vpmulhw';
PMULLD          :       'pmulld';
VPMULLD         :       'vpmulld';
VPMULLQ         :       'vpmullq';
PMULLW          :       'pmullw';
VPMULLW         :       'vpmullw';
PMULUDQ         :       'pmuludq';
VPMULUDQ        :       'vpmuludq';
POP             :       'pop';
POPA		:	'popa';
POPAD		:	'popad';
POPCNT          :       'popcnt';
POPF		:	'popf';
POPFD		:	'popfd';
POPFQ		:	'popfq';
POR             :       'por';
VPOR            :       'vpor';
VPORD           :       'vpord';
VPORQ           :       'vporq';
PREFETCHT0      :       'prefetcht0';
PREFETCHT1      :       'prefetcht1';
PREFETCHT2      :       'prefetcht2';
PREFETCHNTA      :       'prefetchnta';
PREFETCHW       :       'prefetchw' ; 
PREFETCHWT1     :       'prefetchwt1';
PSADBW          :       'psadbw';
VPSADBW         :       'vpsadbw';
PSHUFB          :       'pshufb';
VPSHUFB         :       'vpshufb';
PSHUFD          :       'pshufd';
VPSHUFD         :       'vpshufd';
PSHUFHW         :       'pshufhw';
VPSHUFHW        :       'vpshufhw';
PSHUFLW         :       'pshuflw';
VPSHUFLW        :       'vpshuflw';
PSHUFW          :       'pshufw';
PSIGNB          :       'psignb';
PSIGNW          :       'psignw';
PSIGND          :       'psignd';
VPSIGNB         :       'vpsignb';
VPSIGNW         :       'vpsignw';
VPSIGND         :       'vpsignd';
PSLLDQ          :       'pslldq';
VPSLLDQ         :       'vpslldq';
PSLLW           :       'psllw';
PSLLD           :       'pslld';
PSLLQ           :       'psllq';
VPSLLW          :       'vpsllw';
VPSLLD          :       'vpslld';
VPSLLQ          :       'vpsllq';
PSRAW           :       'psraw';
PSRAD           :       'psrad';
VPSRAW          :       'vpsraw';
VPSRAD          :       'vpsrad';
VPSRAQ          :       'vpsraq';
PSRLDQ          :       'psrldq';
VPSRLDQ         :       'vpsrldq';
PSRLW           :       'psrlw';
PSRLD           :       'psrld';
PSRLQ           :       'psrlq';
VPSRLW          :       'vpsrlw';
VPSRLD          :       'vpsrld';
VPSRLQ          :       'vpsrlq';
PSUBB           :       'psubb';
PSUBW           :       'psubw';
PSUBD           :       'psubd';
VPSUBB          :       'vpsubb';
VPSUBW          :       'vpsubw';
VPSUBD          :       'vpsubd';
PSUBQ           :       'psubq';
VPSUBQ          :       'vpsubq';
PSUBSB          :       'psubsb';
PSUBSW          :       'psubsw';
VPSUBSB         :       'vpsubsb';
VPSUBSW         :       'vpsubsw';
PSUBUSB         :       'psubusb';
PSUBUSW         :       'psubusw';
PTEST           :       'ptest';
VPTEST          :       'vptest';
PTWRITE         :       'ptwrite';
PUNPCKHBW       :       'punpckhbw';
PUNPCKHBD       :       'punpckhbd';
PUNPCKHBQ       :       'punpckhbq';
PUNPCKHQDQ      :       'punpckhqdq';
VPUNPCKHBW      :       'vpunpckhbw';
VPUNPCKHWD      :       'vpunpckhwd';
VPUNPCKHDQ      :       'vpunpckhdq';
VPUNPCKHQDQ     :       'vpunpckhqdq';
PUNPCKLBW       :       'punpcklbw';
PUNPCKLBD       :       'punpcklbd';
PUNPCKLBQ       :       'punpcklbq';
PUNPCKLQDQ      :       'punpcklqdq';
VPUNPCKLBW      :       'vpunpcklbw';
VPUNPCKLWD      :       'vpunpcklwd';
VPUNPCKLDQ      :       'vpunpckldq';
VPUNPCKLQDQ     :       'vpunpcklqdq';
PUSH            :       'push';
PUSHA           :       'pusha';
PUSHAD          :       'pushad';
PUSHF		:	'pushf';
PUSHFD		:	'pushfd';
PUSHFQ		:	'pushfq';
PXOR            :       'pxor';
VPXOR           :       'vpxor';
VPXORD          :       'vpxord';
VPXORQ          :       'vpxorq';
RCL             :       'rcl';
RCR             :       'rcr';
ROL             :       'rol';
ROR             :       'ror';
RCPPS           :       'rcpps';
VRCPPS          :       'vrcpps';
RCPSS           :       'rcpss';
VRCPSS          :       'vrcpss';
RDFSBASE        :       'rdfsbase';
RDGSBASE        :       'rdgsbase';
RDMSR		:	'rdmsr';
RDPID           :       'rdpid';
RDPKRU          :       'rdpkru';
RDPMC		:	'rdpmc';
RDRAND       :       'rdrand';
RDSEED       :   'rdseed';
RDTSC		:	'rdtsc';
RDTSCP		:	'rdtscp';
REPINS		:	'REPINS';
REP			:	'rep';
REPE			:    'repe';
REPNE		:    'repne';
RET			:	'ret';
RORX            :       'rorx';
ROUNDPD         :       'roundpd';
VROUNDPD        :       'vroundpd';
ROUNDPS         :       'roundps';
VROUNDPS        :       'vroundps';
ROUNDSD         :       'roundsd';
VROUNDSD        :       'vroundsd';
ROUNDSS         :       'roundss';
VROUNDSS        :       'vroundss';
RSM		:	'rsm';
RSQRTPS         :       'rsqrtps';
VRSQRTPS        :       'vrsqrtps';
VSQRTSS         :       'vsqrtss';
VRSQRTSS        :       'vrsqrtss';
SAHF		:	'sahf';
SAL             :       'sal';
SAR             :       'sar';
SHR             :       'shr';
SHL			   :		   'shl';
SARX            :       'sarx';
SHLX            :       'shlx';
SHRX            :       'shrx';
SBB             :       'sbb';
SCAS            :       'scas';
SCASB           :       'scasb';
SCASW           :       'scasw';
SCASD           :       'scasd';
SCASQ           :       'scasq';
SETCC		    :	   'seta'| 'setae'| 'setb'|'setbe'|'setc'|'sete'| 'setg'|'setge'|'setl'|'setle'|'setna'|'setnae'|'setnb'|'setnbe'| 'setnc'|'setne'|'setng'
				|		'setnge'|'setnl'|'setnle'|'setno'|'setnp'|'setns'|'setnz'|'seto'|'setp'|'setpe'|'setpo'|'sets'|'setz';
SFENCE          :       'sfence';
SGDT            :       'sgdt';
SHA1RNDS4       :       'sha1rnds4';
SHA1NEXTE       :       'sha1nexte';
SHA1MSG1        :       'sha1msg1';
SHA1MSG2        :       'sha1msg2';
SHA256RNDS2     :       'sha256rnds2';
SHA256MSG1      :       'sha256msg1';
SHA256MSG2      :       'sha256msg2';
SHLD            :       'shld';
SHRD            :       'shrd';
SHUFPD          :       'shufpd';
VSHUFPD         :       'vshufpd';
SHUFPS          :       'shufps';
VSHUFPS         :       'vshufps';
SIDT            :       'sidt';
SLDT            :       'sldt';
SMSW            :       'smsw';
SQRTPD          :       'sqrtpd';
VSQRTPD         :       'vsqrtpd';
SQRTPS          :       'sqrtps';
VSQRTPS         :       'vsqrtps';
SQRTSD          :       'sqrtsd';
VSQRTSD         :       'vsqrtsd';
SQRTSS          :       'sqrtss';
STAC            :       'stac';
STC		:	'stc';
STD		:	'std';
STI		:	'sti';
STMXCSR         :       'stmxcsr';
VSTMXCSR        :       'vstmxcsr';
STOS            :       'stos';
STOSB           :       'stosb';
STOSW           :       'stosw';
STOSD           :       'stosd';
STOSQ           :       'stosq';
STR             :       'str';
SUB             :       'sub';
SUBPD           :       'subpd';
VSUBPD          :       'vsubpd';
SUBPS           :       'subps';
VSUBPS          :       'vsubps';
SUBSD           :       'subsd';
VSUBSD          :       'vsubsd';
SUBSS           :       'subss';
VSUBSS          :       'vsubss';
SWAPGS		:	'swapgs';
SYSCALL		:	'syscall';
SYSENTER	:	'sysenter';
SYSEXIT         :       'sysexit';
SYSRET          :       'sysret';
TEST            :       'test';
TPAUSE          :       'tpause';
TZCNT           :       'tzcnt';
UCOMISD         :       'ucomisd';
VUCOMISD        :       'vucomisd';
UCOMISS         :       'ucomiss';
VUCOMISS        :       'vucomiss';
UD0             :       'ud0';
UD1             :       'ud1';
UD2             :       'ud2';
UMONITOR        :       'umonitor';
UMWAIT          :       'umwait';
UNPCKHPD        :       'unpckhpd';
VUNPCKHPD       :       'vunpckhpd';
UNPCKHPS        :       'unpckhps';
VUNPCKHPS       :       'vunpckhps';
UNPCKLPD        :       'unpcklpd';
VUNPCKLPD       :       'vunpcklpd';
UNPCKLPS        :       'unpcklps';
VUNPCKLPS       :       'vunpcklps';
VALIGND         :       'valignd';
VALIGNQ         :       'valignq';
VBLENDMPD       :       'vblendmpd';
VBLENDMPS       :       'vblendmps';
VBROADCASTSS    :       'vbroadcastss';
VBROADCASTSD    :       'vbroadcastsd';
VBROADCASTF128  :       'vbroadcastf128';
VBROADCASTF32X2 :       'vbroadcastf32x2';
VBROADCASTF32X4 :       'vbroadcastf32x4';
VBROADCASTF64X2 :       'vbroadcastf64x2';
VBROADCASTF32X8 :       'vbroadcastf32x8';
VBROADCASTF64X4 :       'vbroadcastf64x4';
VCOMPRESSPD     :       'vcompresspd';
VCOMPRESSPS     :       'vcompressps';
VCVTPD2QQ       :       'vcvtpd2qq';
VCVTPD2UDQ      :       'vcvtpd2udq';
VCVTPD2UQQ      :       'vcvtpd2uqq';
VCVTPH2PS       :       'vcvtph2ps';
VCVTPS2PH       :       'vcvtps2ph';
VCVTPS2UDQ      :       'vcvtps2udq';
VCVTPS2QQ       :       'vcvtps2qq';
VCVTPS2UQQ      :       'vcvtps2uqq';
VCVTQQ2PD       :       'vcvtqq2pd';
VCVTQQ2PS       :       'vcvtqq2ps';
VCVTSD2USI      :       'vcvtsd2usi';
VCVTSS2USI      :       'vcvtss2usi';
VCVTTPD2QQ      :       'vcvttpd2qq';
VCVTTPD2UDQ     :       'vcvttpd2udq';
VCVTTPD2UQQ     :       'vcvttpd2uqq';
VCVTTPS2UDQ     :       'vcvttps2udq';
VCVTTPS2QQ      :       'vcvttps2qq';
VCVTTPS2UQQ     :       'vcvttps2uqq';
VCVTTSD2USI     :       'vcvttsd2usi';
VCVTTSS2USI     :       'vcvttss2usi';
VCVTUDQ2PD      :       'vcvtudq2pd';
VCVTUDQ2PS      :       'vcvtudq2ps';
VCVTUQQ2PD      :       'vcvtuqq2pd';
VCVTUQQ2PS      :       'vcvtuqq2ps';
VCVTUSI2SD      :       'vcvtusi2sd';
VCVTUSI2SS      :       'vcvtusi2ss';
VDBPSADBW       :       'vdbpsadbw';
VEXPANDPD       :       'vexpandpd';
VEXPANDPS       :       'vexpandps';
VERR            :       'verr';
VERW            :       'verw';
VEXTRACTF128    :       'vextractf128';
VEXTRACTI128    :       'vextracti128';
VFIXUPIMMPD     :       'vfixupimmpd';
VFIXUPIMMPS     :       'vfixupimmps';
VFIXUPIMMSD     :       'vfixupimmsd';
VFIXUPIMMSS     :       'vfixupimmss';
VFMADD132PD     :       'vfmadd132pd';
VFMADD123PD     :       'vfmadd123pd';
VFMADD231PD     :       'vfmadd231pd';
VFMADD132PS     :       'vfmadd132ps';
VFMADD213PS     :       'vfmadd213ps';
VFMADD231PS     :       'vfmadd231ps';
VFMADD132SD     :       'vfmadd132sd';
VFMADD213SD     :       'vfmadd213sd';
VFMADD231SD     :       'vfmadd231sd';
VFMADD132SS     :       'vfmadd132ss';
VFMADD213SS     :       'vfmadd213ss';
VFMADD231SS     :       'vfmadd231ss';
VFMADDSUB132PD  :       'vfmaddsub132pd';
VFMADDSUB213PD  :       'vfmaddsub213pd';
VFMADDSUB231PD  :       'vfmaddsub231pd';
VFMADDSUB132PS  :       'vfmaddsub132ps';
VFMADDSUB213PS  :       'vfmaddsub213ps';
VFMADDSUB231PS  :       'vfmaddsub231ps';
VFMSUBADD132PD  :       'vfmsubadd132pd';
VFMSUBADD213PD  :       'vfmsubadd213pd';
VFMSUBADD231PD  :       'vfmsubadd231pd';
VFMSUBADD132PS  :       'vfmsubadd132ps';
VFMSUBADD213PS  :       'vfmsubadd213ps';
VFMSUBADD231PS  :       'vfmsubadd231ps';
VFMSUB132PD     :       'vfmsub132pd';
VFMSUB213PD     :       'vfmsub213pd';
VFMSUB231PD     :       'vfmsub231pd';
VFMSUB132PS     :       'vfmsub132ps';
VFMSUB213PS     :       'vfmsub213ps';
VFMSUB231PS     :       'vfmsub231ps';
VFMSUB132SD     :       'vfmsub132sd';
VFMSUB213SD     :       'vfmsub213sd';
VFMSUB231SD     :       'vfmsub231sd';
VFMSUB132SS     :       'vfmsub132ss';
VFMSUB213SS     :       'vfmsub213ss';
VFMSUB231SS     :       'vfmsub231ss';
VFNMADD132PD    :       'vfnmadd132pd';
VFNMADD213PD    :       'vfnmadd213pd';
VFNMADD231PD    :       'vfnmadd231pd';
VFNMADD132PS    :       'vfnmadd132ps';
VFNMADD213PS    :       'vfnmadd213ps';
VFNMADD231PS    :       'vfnmadd231ps';
VFNMADD132SD    :       'vfnmadd132sd';
VFNMADD213SD    :       'vfnmadd213sd';
VFNMADD231SD    :       'vfnmadd231sd';
VFNMADD132SS    :       'vfnmadd132ss';
VFNMADD213SS    :       'vfnmadd213ss';
VFNMADD231SS    :       'vfnmadd231ss';
VFNMSUB132PD    :       'vfnmsub132pd';
VFNMSUB213PD    :       'vfnmsub213pd';
VFNMSUB231PD    :       'vfnmsub231pd';
VFNMSUB132PS    :       'vfnmsub132ps';
VFNMSUB213PS    :       'vfnmsub213ps';
VFNMSUB231PS    :       'vfnmsub231ps';
VFNMSUB132SD    :       'vfnmsub132sd';
VFNMSUB213SD    :       'vfnmsub213sd';
VFNMSUB231SD    :       'vfnmsub231sd';
VFNMSUB132SS    :       'vfnmsub132ss';
VFNMSUB213SS    :       'vfnmsub213ss';
VFNMSUB231SS    :       'vfnmsub231ss';
VFPCLASSPD      :       'vfpclasspd';
VFPCLASSPS      :       'vfpclassps';
VFPCLASSSD      :       'vfpclasssd';
VFPCLASSSS      :       'vfpclassss';
VGATHERDPD      :       'vgatherdpd';
VGATHERQPD      :       'vgatherqpd';
VGATHERDPS      :       'vgatherdps';
VGATHERQPS      :       'vgatherqps';
VGETEXPPD       :       'vgetexppd';
VGETEXPPS       :       'vgetexpps';
VGETEXPSD       :       'vgetexpsd';
VGETEXPSS       :       'vgetexpss';
VGETMANTPD      :       'vgetmantpd';
VGETMANTPS      :       'vgetmantps';
VGETMANTSD      :       'vgetmantsd';
VGETMANTSS      :       'vgetmantss';
VINSERTF128     :       'vinsertf128';
VINSERTF32X4    :       'vinsertf32x4';
VINSERTF64X2    :       'vinsertf64x2';
VINSERTF32X8    :       'vinsertf32x8';
VINSERTF64X4    :       'vinsertf64x4';
VINSERTI128     :       'vinserti128';
VINSERTI32X4    :       'vinserti32x4';
VINSERTI64X2    :       'vinserti64x2';
VINSERTI32X8    :       'vinserti32x8';
VINSERTI64X4    :       'vinserti64x4';
VMASKMOVPS      :       'vmaskmovps';
VMASKMOVPD      :       'vmaskmovpd';
VPBLENDD        :       'vpblendd';
VPBLENDMB       :       'vpblendmb';
VPBLENDMW       :       'vpblendmw';
VPBLENDMD       :       'vpblendmd';
VPBLENDMQ       :       'vpblendmq';
VPBROADCASTB    :       'vpbroadcastb';
VPBROADCASTW    :       'vpbroadcastw';
VPBROADCASTD    :       'vpbroadcastd';
VPBRPADCASTQ    :       'vpbrpadcastq';
VBROADCASTI32X2 :       'vbroadcasti32x2';
VBROADCASTI128  :       'vbroadcasti128';
VBROADCASTI32X4 :       'vbroadcasti32x4';
VBROADCASTI64X2 :       'vbroadcasti64x2';
VBROADCASTI32X8 :       'vbroadcasti32x8';
VBROADCASTI64X4 :       'vbroadcasti64x4';
VPBROADCASTMB2Q :       'vpbroadcastmb2q';
VPBROADCASTMW2D :       'vpbroadcastmw2d';
VPCMPB          :       'vpcmpb';
VPCMPUB         :       'vpcmpub';
VPCMPD          :       'vpcmpd';
VPCMPUD         :       'vpcmpud';
VPCMPQ          :       'vpcmpq';
VPCMPUQ         :       'vpcmpuq';
VPCMPW          :       'vpcmpw';
VPCMPUW         :       'vpcmpuw';
VPCOMPRESSD     :       'vpcompressd';
VPCOMPRESSQ     :       'vpcompressq';
VPCONFLICTD     :       'vpconflictd';
VPCONFLICTQ     :       'vpconflictq';
VPERM2F128      :       'vperm2f128';
VPERM2I128      :       'vperm2i128';
VPERMB          :       'vpermb';
VPERMD          :       'vpermd';
VPERMW          :       'vpermw';
VPERMI2B        :       'vpermi2b';
VPERMI2W        :       'vpermi2w';
VPERMI2D        :       'vpermi2d';
VPERMI2Q        :       'vpermi2q';
VPERMI2PS       :       'vpermi2ps';
VPERMI2PD       :       'vpermi2pd';
VPERMILPD       :       'vpermilpd';
VPERMILPS       :       'vpermilps';
VPERMPD         :       'vpermpd';
VPERMPS         :       'vpermps';
VPERMQ          :       'vpermq';      
VPERMT2B        :       'vpermt2b';
VPERMT2W        :       'vpermt2w';
VPERMT2D        :       'vpermt2d';
VPERMT2Q        :       'vpermt2q';
VPERMT2PS       :       'vpermt2ps';
VPERMT2PD       :       'vpermt2pd';
VPEXPANDD       :       'vpexpandd';
VPEXPANDQ       :       'vpexpandq';
VPGATHERDD      :       'vpgatherdd';
VPGATHERQD      :       'vpgatherqd';
VPGATHERDQ      :       'vpgatherdq';
VPGATHERQQ      :       'vpgatherqq';
VPLZCNTD        :       'vplzcntd';
VPLZCNTQ        :       'vplzcntq';
VPMADD52HUQ     :       'vpmadd52huq';
VPMADD52LUQ     :       'vpmadd52luq';
VPMASKMOVD      :       'vpmaskmovd';
VPMASKMOVQ      :       'vpmaskmovq';
VPMOVB2M        :       'vpmovb2m';
VPMOVDB         :       'vpmovdb';
VPMOVSDB        :       'vpmovsdb';
VPMOVUSDB       :       'vpmovusdb';
VPMOVDW         :       'vpmovdw';
VPMOVSDW        :       'vpmovsdw';
VPMOVUSDW       :       'vpmovusdw';
VPMOVM2B        :       'vpmovm2b';
VPMOVM2W        :       'vpmovm2w';
VPMOVM2D        :       'vpmovm2d';
VPMOVM2Q        :       'vpmovm2q';
VPMOVQB         :       'vpmovqb';
VPMOVSQB        :       'vpmovsqb';
VPMOVUSQB       :       'vpmovusqb';
VPMOVQD         :       'vpmovqd';
VPMOVSQD        :       'vpmovsqd';
VPMOVUSQD       :       'vpmovusqd';
VPMOVQW         :       'vpmovqw';
VPMOVSQW        :       'vpmovsqw';
VPMOVUSQW       :       'vpmovusqw';
VPMOVWB         :       'vpmovwb';
VPMOVSWB        :       'vpmovswb';
VPMOVUSWB       :       'vpmovuswb';
VPMULTISHIFTQB  :       'vpmultishiftqb';
VPROLVD         :       'vprolvd';
VPROLD          :       'vprold';
VPROLVQ         :       'vprolvq';
VPROLQ          :       'vprolq';
VPRORVD         :       'vprorvd';
VPRORD          :       'vprord';
VPRORVQ         :       'vprorvq';
VPRORQ          :       'vprorq';
VPSCATTERDD     :       'vpscatterdd';
VPSCATTERDQ     :       'vpscatterdq';
VPSCATTERQD     :       'vpscatterqd';
VPSCATTERQQ     :       'vpscatterqq';
VPSLLVD         :       'vpsllvd';
VPSLLVQ         :       'vpsllvq';
VPSLLVW         :       'vpsllvw';
VPSRAVD         :       'vpsravd';
VPSRAVW         :       'vpsravw';
VPSRAVQ         :       'vpsravq';
VPSRLVD         :       'vpsrlvd';
VPSRLVQ         :       'vpsrlvq';
VPSRLVW         :       'vpsrlvw';
VPTERNLOGD      :       'vpternlogd';
VPTERNLOGQ      :       'vpternlogq';
VPTESMB         :       'vptesmb';
VPTESMW         :       'vptesmw';
VPTESMD         :       'vptesmd';
VPTESMQ         :       'vptesmq';
VPTESTNMB       :       'vptestnmb';
VPTESTNMW       :       'vptestnmw';
VPTESTNMD       :       'vptestnmd';
VPTESTNMQ       :       'vptestnmq';
VRANGEPD        :       'vrangepd';
VRANGEPS        :       'vrangeps';
VRANGESD        :       'vrangesd';
VRANGESS        :       'vrangess';
VRCP14PD        :       'vrcp14pd';
VRCP14SD        :       'vrcp14sd';
VRCP14PS        :       'vrcp14ps';
VRCP14SS        :       'vrcp14ss';
VREDUCEPD       :       'vreducepd';
VREDUCESD       :       'vreducesd';
VREDUCEPS       :       'vreduceps';
VREDUCESS       :       'vreducess';
VRNDSCALEPD     :       'vrndscalepd';
VRNDSCALESD     :       'vrndscalesd';
VRNDSCALEPS     :       'vrndscaleps';
VRNDSCALESS     :       'vrndscaless';
VRSQRT14PD      :       'vrsqrt14pd';
VRSQRT14SD      :       'vrsqrt14sd';
VRSQRT14PS      :       'vrsqrt14ps';
VRSQRT14SS      :       'vrsqrt14ss';
VSCALEFPD       :       'vscalefpd';
VSCALEFSD       :       'vscalefsd';
VSCALEFPS       :       'vscalefps';
VSCALEFSS       :       'vscalefss';
VSCATTERDPS     :       'vscatterdps';
VSCATTERDPD     :       'vscatterdpd';
VSCATTERQPS     :       'vscatterqps';
VSCATTERQPD     :       'vscatterqpd';
VSHUFF32X4      :       'vshuff32x4';
VSHUFF64X2      :       'vshuff64x2';
VSHUFI32X4      :       'vshufi32x4';
VSHUFI64X2      :       'vshufi64x2';
VTESTPS         :       'vtestps';
VTESTPD         :       'vtestpd';
VZEROALL        :       'vzeroall';
VZEROUPPER      :       'vzeroupper';
WAIT1		:	'wait';
FWAIT		:	'fwait';
WBINVD		:	'wbinvd';
WRFSBASE        :       'wrfsbase';
WRGSBASE        :       'wrgsbase';
WRMSR		:	'wrmsr';
WRPKRU          :       'wrpkru';
XACQUIRE        :       'xacquire';
XRELEASE        :       'xrelease';
XABORT          :       'xabort';
XADD            :       'xadd';
XBEGIN          :       'xbegin';
XCHG            :       'xchg';
XEND            :       'xend';
XGETBV          :       'xgetbv';
XLAT            :       'xlat';
XLATB           :       'xlatb';
XOR             :       'xor';
XORPD           :       'xorpd';
VXORPD          :       'vxorpd';
XORPS           :       'xorps';
VXORPS          :       'vxorps';
XRSTOR          :       'xrstor';
XRSTOR64        :       'xrstor64';
XRSTORS         :       'xrstors';
XRSTORS64       :       'xrstors64';
XSAVE           :       'xsave';
XSAVE64         :       'xsave64';
XSAVEC          :       'xsavec';
XSAVEC64        :       'xsavec64';
XSAVEOPT        :       'xsaveopt';
XSAVEOPT64      :       'xsaveopt64';
XSAVES          :       'xsaves';
XSAVES64        :       'xsaves64';
XSETBV          :       'xsetbv';
XTEST           :       'xtest';

//NUMBER     :       '0x'? [a-f0-9]+;
/*


IMM8	:	'0x' [0-9a-fA-F][0-9a-fA-F]? (MATH_SYMBOL '0x' [0-9a-fA-F][0-9a-fA-F]?)* //should be work
		|	('-'[1-9]
		|	'-''12'[0-8]
		|	'-'?[1-9][0-9]
		|	'-'?'1'[01][0-9]
		|	[0-9]
		|	'12'[0-7])
		;*/
/*
IMM16	:	'0x' [0-9a-fA-F] [0-9a-fA-F]? [0-9a-fA-F]? [0-9a-fA-F]? (MATH_SYMBOL '0x' [0-9a-fA-F][0-9a-fA-F]?[0-9a-fA-F]? [0-9a-fA-F]?)*
		|	('-'[1-9]
		|	'-''3276'[0-8]
		|	'-'?[1-9][0-9]
		|	'-'?[1-9][0-9][0-9]
		|	'-'?[1-9][0-9][0-9][0-9]
		|	'-'?[12][0-9][0-9][0-9][0-9]
		|	'-'?'3'[01][0-9][0-9][0-9]
		|	'-'?'32'[0-6][0-9][0-9]
		|	'-'?'327'[0-5][0-9]
		|	[0-9]
		|	'3276'[0-7])
		;

IMM32	:	'0x'? [0-9a-fA-F] [0-9a-fA-F]? [0-9a-fA-F]? [0-9a-fA-F]? [0-9a-fA-F]? [0-9a-fA-F]? [0-9a-fA-F]? [0-9a-fA-F]? (MATH_SYMBOL '0x' [0-9a-fA-F][0-9a-fA-F]?[0-9a-fA-F]? [0-9a-fA-F]? [0-9a-fA-F]? [0-9a-fA-F]? [0-9a-fA-F]? [0-9a-fA-F]?)* 
		|	('-'[1-9]
		|	'-''214748364'[0-8]
		|	'-'?[1-9][0-9]
		|	'-'?[1-9][0-9][0-9]
		|	'-'?[1-9][0-9][0-9][0-9]
		|	'-'?[1-9][0-9][0-9][0-9][0-9]
		|	'-'?[1-9][0-9][0-9][0-9][0-9][0-9]
		|	'-'?[1-9][0-9][0-9][0-9][0-9][0-9][0-9]
		|	'-'?[1-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]
		|	'-'?[1-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]
		|	'-'?'1'[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]
		|	'-'?'20'[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]
		|	'-'?'21'[0-3][0-9][0-9][0-9][0-9][0-9][0-9][0-9]
		|	'-'?'214'[0-6][0-9][0-9][0-9][0-9][0-9][0-9]
		|	'-'?'2147'[0-3][0-9][0-9][0-9][0-9][0-9]
		|	'-'?'21474'[0-7][0-9][0-9][0-9][0-9]
		|	'-'?'214748'[0-2][0-9][0-9][0-9]
		|	'-'?'2147483'[0-5][0-9][0-9]
		|	'-'?'21474836'[0-3][0-9]
		|	[0-9]
		|	'214748364'[0-7])
		;*/

//NUMBER	:	'0x'? [0-9]+;
TIME2   :     '*2';//MUL_SYMBOL '2'
TIME4   :     '*4';
TIME8   :     '*8';
//MEM8	:	'[' IMM ']';
STRING	:	'"' ~["]* '"';

RAX		:	'rax';
EAX		:	'eax';
AX		:	'ax';
AH		:	'ah';
AL		:	'al';
RBX		:	'rbx';
EBX		:	'ebx';
BX		:	'bx';
BH		:	'bh';
BL		:	'bl';
RCX		:	'rcx';
ECX		:	'ecx';
CX		:	'cx';
CH		:	'ch';
CL		:	'cl';
RDX		:	'rdx';
EDX		:	'edx';
DX		:	'dx';
DH		:	'dh';
DL		:	'dl';
RBP		:	'rbp';
EBP		:	'ebp';
BP		:	'bp';
RSP		:	'rsp';
ESP		:	'esp';
SP		:	'sp';
RSI		:	'rsi';
ESI		:	'esi';
SI		:	'si';
RDI		:	'rdi';
EDI		:	'edi';
DI		:	'di';
R8		:	'r8';
R8D		:	'r8d';
R8W		:	'r8w';
R8L		:	'r8l';
R9		:	'r9';
R9D		:	'r9d';
R9W		:	'r9w';
R9L		:	'r9l';
R10		:	'r10';
R10D	:	'r10d';
R10W	:	'r10w';
R10L	:	'r10l';
R11		:	'r11';
R11D	:	'r11d';
R11W	:	'r11w';
R11L	:	'r11l';
R12		:	'r12';
R12D	:	'r12d';
R12W	:	'r12w';
R12L	:	'r12l';
R13		:	'r13';
R13D	:	'r13d';
R13W	:	'r13w';
R13L	:	'r13l';
R14		:	'r14';
R14D	:	'r14d';
R14W	:	'r14w';
R14L	:	'r14l';
R15		:	'r15';
R15D	:	'r15d';
R15W	:	'r15w';
R15L	:	'r15l';
RFLAGS	:	'rflags';
EFLAGS	:	'eflags';
RIP		:	'rip';
EIP		:	'eip';
CS		:	'cs';
DS		:	'ds';
SS              :       'ss';
ES		:	'es';
FS		:	'fs';
GS		:	'gs';
BPL		:	'bpl';
SPL		:	'spl';
DIL		:	'dil';
SIL		:	'sil';
XMM0	:	'xmm0';
XMM1	:	'xmm1';
XMM2	:	'xmm2';
XMM3	:	'xmm3';
XMM4	:	'xmm4';
XMM5	:	'xmm5';
XMM6	:	'xmm6';
XMM7	:	'xmm7';
MM0		:	'mm0';
MM1		:	'mm1';
MM2		:	'mm2';
MM3		:	'mm3';
MM4		:	'mm4';
MM5		:	'mm5';
MM6		:	'mm6';
MM7		:	'mm7';

ZERO            :        '0';
ONE             :        '1';

IDENTIFIER	:	[a-zA-Z] [a-zA-Z0-9]+;
SECTION_NAME	:	'.' IDENTIFIER;


